package com.tptj.demo.hg.designer.frame.up.button.provider;

import com.fr.design.fun.impl.AbstractDsinFrameUpButtonProvider;
import com.fr.design.gui.ibutton.UIButton;
import com.fr.design.mainframe.DesignerContext;
import com.fr.design.mainframe.JTemplate;
import com.fr.design.mainframe.JWorkBook;
import com.fr.general.GeneralUtils;
import com.fr.general.IOUtils;
import com.fr.intelli.record.Focus;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.report.cell.DefaultTemplateCellElement;
import com.fr.report.cell.TemplateCellElement;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-19
 **/
@EnableMetrics
public class Demo extends AbstractDsinFrameUpButtonProvider {

    @Override
    public int currentAPILevel() {
        return CURRENT_LEVEL;
    }

    @Override
    @Focus(id = "com.tptj.demo.hg.designer.frame.up.button.provider.v10",text = "designer frame up button")
    public UIButton[] getUpButtons(int menuState) {
        UIButton btn = new UIButton(IOUtils.readIcon("/com/fr/base/images/cell/control/remove.png"));
        btn.addActionListener(new AbstractAction() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JTemplate<?, ?> template = DesignerContext.getDesignerFrame().getSelectedJTemplate();
                if( template instanceof JWorkBook ){
                    //设置当前编辑页面的C4单元格 值每次+1
                    TemplateCellElement cell = ((JWorkBook) template).getEditingElementCase().getTemplateCellElement(2, 3);
                    if( null == cell ){
                        cell = new DefaultTemplateCellElement(2,3);
                        ((JWorkBook)template).getEditingElementCase().addCellElement(cell);
                    }
                    cell.setValue(GeneralUtils.objectToNumber(cell.getValue()).intValue() + 1 );
                    template.fireTargetModified();
                }
                //FineJOptionPane.showMessageDialog(DesignerContext.getDesignerFrame(),"Hello World!");
            }
        });
        return new UIButton[]{
                btn
        };
    }
}
